package rozdzial07c;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.embed.swing.SwingFXUtils;
import javafx.scene.Cursor;
import javafx.scene.Scene;
import javafx.scene.SnapshotParameters;
import javafx.scene.SnapshotResult;
import javafx.scene.control.Label;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyCodeCombination;
import javafx.scene.input.KeyCombination;
import javafx.scene.layout.HBox;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;
import javafx.util.Callback;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
/**
 * @author Jacek Piechota
 <p>Migawka z węzła {@code Node} - sposób 2.</p>
 <p>Po uruchomieniu klasy i kliknięciu 'Ctrl-C' otrzymamy obrazek</p>
 <img src="rys07_02.png" width="410" height="210" alt="Migawka z węzła">
 */
public class Listing07c_01b extends Application {
    public static void main(String[] args) {
        Application.launch(args);
    }

    @Override
    public void start(Stage stage) {
        try {
            Label label = new Label("Zrzut ekranu po naciśnięciu 'Ctrl+C'");
            Circle circle = new Circle(50, 50, 30);
            circle.setFill(Color.BLUE);
            HBox root = new HBox();
            root.setSpacing(20);
            root.getChildren().addAll(label, circle);
            Scene scene = new Scene(root, 410, 200);
            scene.setCursor(Cursor.DEFAULT);
            KeyCombination kk = new KeyCodeCombination(KeyCode.C,
                    KeyCombination.CONTROL_DOWN);
            SnapshotParameters params = new SnapshotParameters();
            scene.getAccelerators().put(kk, () -> {
                Callback<SnapshotResult, Void> c =
                        new Callback<SnapshotResult, Void>() {
                    @Override
                    public Void call(SnapshotResult sr) {
                        File file = new File(
                                "rozdzial07c/src/rozdzial07c/rys07_02.png");
                        BufferedImage bi = SwingFXUtils
                                .fromFXImage(sr.getImage(), null);
                        try {
                            ImageIO.write(bi, "png", file);
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        return null;
                    }
                };
                root.snapshot(c, params, null);
            });
            stage.setScene(scene);
            stage.setTitle("Node");
            stage.setOnCloseRequest(e -> Platform.exit());
            stage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
